Index: sbin/etherswitchcfg/etherswitchcfg.c
===================================================================
--- sbin/etherswitchcfg/etherswitchcfg.c	(revision 250908)
+++ sbin/etherswitchcfg/etherswitchcfg.c	(working copy)
@@ -471,8 +471,9 @@
 	vg.es_vlangroup = vlangroup;
 	if (ioctl(cfg->fd, IOETHERSWITCHGETVLANGROUP, &vg) != 0)
 		err(EX_OSERR, "ioctl(IOETHERSWITCHGETVLANGROUP)");
-	if (vg.es_vid == 0 && vg.es_member_ports == 0)
+	if ((vg.es_vid & ETHERSWITCH_VID_VALID) == 0)
 		return;
+	vg.es_vid &= ETHERSWITCH_VID_MASK;
 	printf("vlangroup%d:\n", vlangroup);
 	if (cfg->conf.vlan_mode == ETHERSWITCH_VLAN_PORT)
 		printf("\tport: %d\n", vg.es_vid);
@@ -626,7 +627,9 @@
 				newmode(&cfg, MODE_PORT);
 			} else if (sscanf(argv[0], "vlangroup%d", &cfg.unit) == 1) {
 				if (cfg.unit < 0 || cfg.unit >= cfg.info.es_nvlangroups)
-					errx(EX_USAGE, "port unit must be between 0 and %d", cfg.info.es_nvlangroups);
+					errx(EX_USAGE,
+					    "vlangroup unit must be between 0 and %d",
+					    cfg.info.es_nvlangroups - 1);
 				newmode(&cfg, MODE_VLANGROUP);
 			} else if (strcmp(argv[0], "config") == 0) {
 				newmode(&cfg, MODE_CONFIG);
Index: sys/dev/etherswitch/etherswitch.h
===================================================================
--- sys/dev/etherswitch/etherswitch.h	(revision 250908)
+++ sys/dev/etherswitch/etherswitch.h	(working copy)
@@ -26,6 +26,8 @@
 typedef struct etherswitch_phyreg etherswitch_phyreg_t;
 
 #define	ETHERSWITCH_NAMEMAX		64
+#define	ETHERSWITCH_VID_MASK		0xfff
+#define	ETHERSWITCH_VID_VALID		(1 << 12)
 #define	ETHERSWITCH_VLAN_ISL		(1 << 0)	/* ISL */
 #define	ETHERSWITCH_VLAN_PORT		(1 << 1)	/* Port based vlan */
 #define	ETHERSWITCH_VLAN_DOT1Q		(1 << 2)	/* 802.1q */
